"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupSshKey = setupSshKey;
const fsp = require("fs/promises");
const fs = require("fs");
const util = require("util");
const cp = require("child_process");
const _00_configurations_1 = require("./00_configurations");
/**
 * 确保 SSH 密钥对存在，如果不存在则生成。
 */
function setupSshKey(postStatus) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!fs.existsSync(_00_configurations_1.sshDir)) {
            yield fsp.mkdir(_00_configurations_1.sshDir, { recursive: true, mode: 0o700 });
        }
        if (!fs.existsSync(_00_configurations_1.privateKeyPath) || !fs.existsSync(_00_configurations_1.publicKeyPath)) {
            if (fs.existsSync(_00_configurations_1.privateKeyPath))
                yield fsp.rm(_00_configurations_1.privateKeyPath);
            if (fs.existsSync(_00_configurations_1.publicKeyPath))
                yield fsp.rm(_00_configurations_1.publicKeyPath);
            postStatus("生成SSH密钥...");
            const exec = util.promisify(cp.exec);
            yield exec(`ssh-keygen -t rsa -b 4096 -f "${_00_configurations_1.privateKeyPath}" -N ""`);
        }
    });
}
//# sourceMappingURL=03_setup-ssh-key.js.map