"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.configureSshProxy = configureSshProxy;
const fsp = require("fs/promises");
const fs = require("fs");
const _00_configurations_1 = require("./00_configurations");
/**
 * 配置 SSH config 文件以使用 socat 代理。
 */
function configureSshProxy(username, postStatus) {
    return __awaiter(this, void 0, void 0, function* () {
        postStatus("配置SSH代理...");
        const escapedSocatPath = _00_configurations_1.socatExePath.replace(/\\/g, '\\\\');
        const configContent = `\nHost ${username}.bigquant\n\tProxyCommand "${escapedSocatPath}" - PROXY:${_00_configurations_1.sshProxyHost}:%h:%p,proxyport=${_00_configurations_1.sshProxyPort}\n\tUser ${_00_configurations_1.sshDefaultUser}\n\tServerAliveInterval ${_00_configurations_1.sshServerAliveInterval}\n\tServerAliveCountMax ${_00_configurations_1.sshServerAliveCountMax}`;
        if (fs.existsSync(_00_configurations_1.sshConfigPath)) {
            const existingContent = yield fsp.readFile(_00_configurations_1.sshConfigPath, 'utf8');
            if (!existingContent.includes(`Host ${username}.bigquant`)) {
                yield fsp.appendFile(_00_configurations_1.sshConfigPath, configContent);
            }
        }
        else {
            yield fsp.writeFile(_00_configurations_1.sshConfigPath, configContent, { mode: 0o600 });
        }
    });
}
//# sourceMappingURL=06_configure-ssh.js.map