"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.uploadPublicKey = uploadPublicKey;
const fsp = require("fs/promises");
const vscode = require("vscode");
const axios_1 = require("axios");
const _00_configurations_1 = require("./00_configurations");
/**
 * 上传公钥到服务器并更新本地 authorized_keys。
 */
function uploadPublicKey(context, postStatus) {
    return __awaiter(this, void 0, void 0, function* () {
        postStatus("上传公钥授权...");
        const publicKey = yield fsp.readFile(_00_configurations_1.publicKeyPath, 'utf8');
        yield fsp.writeFile(_00_configurations_1.authorizedKeysPath, publicKey, { mode: 0o600 });
        const token = yield context.secrets.get("token");
        yield axios_1.default.post(_00_configurations_1.apiKeyUploadUrl, { 'pub_key': publicKey }, { headers: { 'Cookie': `bigjwt=${token}` } });
        vscode.window.showInformationMessage('公钥授权成功！');
    });
}
//# sourceMappingURL=07_upload-public-key.js.map