"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.establishConnection = establishConnection;
const vscode = require("vscode");
const configurations_1 = require("./configurations");
/**
 * Step9: 执行最终的 VS Code 命令以建立远程 SSH 连接。
 */
function establishConnection(username, postStatus) {
    return __awaiter(this, void 0, void 0, function* () {
        postStatus(`正在连接到 ${username}.bigquant...`);
        const remoteUri = vscode.Uri.parse(`vscode-remote://ssh-remote+${username}.bigquant${configurations_1.remoteWorkDir}`);
        yield vscode.commands.executeCommand('vscode.openFolder', remoteUri, { forceNewWindow: true });
        postStatus("连接指令已发送。");
    });
}
//# sourceMappingURL=establish-connection.js.map