"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractAndRenameSocat = extractAndRenameSocat;
const vscode = require("vscode");
const os = require("os");
const fs = require("fs");
const fsp = require("fs/promises");
const unzipper = require("unzipper");
const configurations_1 = require("./configurations");
/**
 * Step5: 解压 socat.zip 并重命名文件夹、删除残留。
 */
function extractAndRenameSocat(postStatus) {
    return __awaiter(this, void 0, void 0, function* () {
        if (os.platform() === 'win32' && (!fs.existsSync(configurations_1.hasDownloadedFlagPath) || !fs.existsSync(configurations_1.hasUsedFlagPath))) {
            postStatus("解压并配置工具...");
            yield fsp.access(configurations_1.socatZipPath, fs.constants.F_OK); // 确认文件存在
            yield vscode.window.withProgress({ location: vscode.ProgressLocation.Notification, title: `正在解压...`, cancellable: false }, () => __awaiter(this, void 0, void 0, function* () {
                yield fs.createReadStream(configurations_1.socatZipPath).pipe(unzipper.Extract({ path: configurations_1.homeDir })).promise();
            }));
            yield fsp.chmod(configurations_1.socatOriginalDirPath, 0o777);
            yield fsp.rename(configurations_1.socatOriginalDirPath, configurations_1.socatTargetDirPath);
            // 删除残留的安装包
            postStatus("删除残留安装包...");
            yield fsp.rm(configurations_1.socatZipPath);
            //写标志文件
            yield fsp.writeFile(configurations_1.hasDownloadedFlagPath, 'downloaded', { mode: 0o600 });
        }
    });
}
//# sourceMappingURL=extract-and-rename.js.map