"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.performInitialCleanup = performInitialCleanup;
const fsp = require("fs/promises");
const fs = require("fs");
const configurations_1 = require("./configurations");
/**
 * Step2: 为首次连接的用户清理旧的配置文件和工具。
 */
function performInitialCleanup(postStatus) {
    return __awaiter(this, void 0, void 0, function* () {
        postStatus("清理旧文件...");
        const filesToRemove = [
            configurations_1.authorizedKeysPath,
            configurations_1.socatZipPath
        ];
        for (const file of filesToRemove) {
            if (fs.existsSync(file))
                yield fsp.rm(file);
        }
        if (fs.existsSync(configurations_1.socatTargetDirPath) && !fs.existsSync(configurations_1.hasDownloadedFlagPath))
            yield fsp.rm(configurations_1.socatTargetDirPath, { recursive: true, force: true });
    });
}
//# sourceMappingURL=initial-cleanup.js.map