"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupSshKey = setupSshKey;
const fsp = require("fs/promises");
const fs = require("fs");
const util = require("util");
const cp = require("child_process");
const configurations_1 = require("./configurations");
/**
 * Step3: 确保 SSH 密钥对存在，如果不存在则生成。
 */
function setupSshKey(postStatus) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!fs.existsSync(configurations_1.sshDir)) {
            yield fsp.mkdir(configurations_1.sshDir, { recursive: true, mode: 0o700 });
        }
        if (!fs.existsSync(configurations_1.privateKeyPath) || !fs.existsSync(configurations_1.publicKeyPath)) {
            if (fs.existsSync(configurations_1.privateKeyPath))
                yield fsp.rm(configurations_1.privateKeyPath);
            if (fs.existsSync(configurations_1.publicKeyPath))
                yield fsp.rm(configurations_1.publicKeyPath);
            if (!fs.existsSync(configurations_1.privateKeyPath2) || !fs.existsSync(configurations_1.publicKeyPath2)) {
                if (fs.existsSync(configurations_1.privateKeyPath2))
                    yield fsp.rm(configurations_1.privateKeyPath2);
                if (fs.existsSync(configurations_1.publicKeyPath2))
                    yield fsp.rm(configurations_1.publicKeyPath2);
                postStatus("生成SSH密钥...");
                const exec = util.promisify(cp.exec);
                yield exec(`ssh-keygen -t ed25519 -f "${configurations_1.privateKeyPath}" -N ""`);
            }
            else if (fs.existsSync(configurations_1.privateKeyPath2) && fs.existsSync(configurations_1.publicKeyPath2)) {
                return;
            }
            if (!fs.existsSync(configurations_1.privateKeyPath) || !fs.existsSync(configurations_1.publicKeyPath)) {
                postStatus("生成SSH密钥...");
                const exec = util.promisify(cp.exec);
                yield exec(`ssh-keygen -t ed25519 -f "${configurations_1.privateKeyPath}" -N ""`);
            }
        }
    });
}
//# sourceMappingURL=setup-ssh-key.js.map