import * as vscode from 'vscode';
import { remoteWorkDir } from './configurations';

/**
 * Step9: 执行最终的 VS Code 命令以建立远程 SSH 连接。
 */
export async function establishConnection(username: string, postStatus: (text: string) => void): Promise<void> {
    postStatus(`正在连接到 ${username}.bigquant...`);
    const remoteUri = vscode.Uri.parse(`vscode-remote://ssh-remote+${username}.bigquant${remoteWorkDir}`);
    await vscode.commands.executeCommand('vscode.openFolder', remoteUri, { forceNewWindow: true });
    postStatus("连接指令已发送。");
}
