import * as fsp from 'fs/promises';
import * as fs from 'fs';
import { authorizedKeysPath, socatZipPath, socatTargetDirPath, hasDownloadedFlagPath } from './configurations';

/**
 * Step2: 为首次连接的用户清理旧的配置文件和工具。
 */
export async function performInitialCleanup(postStatus: (text: string) => void): Promise<void> {
    postStatus("清理旧文件...");

    const filesToRemove = [
        authorizedKeysPath,
        socatZipPath
    ];

    for (const file of filesToRemove) {
        if (fs.existsSync(file)) await fsp.rm(file);
    }
        
    if (fs.existsSync(socatTargetDirPath) && !fs.existsSync(hasDownloadedFlagPath)) await fsp.rm(socatTargetDirPath, { recursive: true, force: true });
}
