import * as fsp from 'fs/promises';
import * as fs from 'fs';
import * as util from 'util';
import * as cp from 'child_process';
import { sshDir, privateKeyPath, publicKeyPath, privateKeyPath2, publicKeyPath2 } from './configurations';

/**
 * Step3: 确保 SSH 密钥对存在，如果不存在则生成。
 */
export async function setupSshKey(postStatus: (text: string) => void): Promise<void> {
    if(!fs.existsSync(sshDir)) {
        await fsp.mkdir(sshDir, { recursive: true, mode: 0o700 });
    }

    if (!fs.existsSync(privateKeyPath) || !fs.existsSync(publicKeyPath)) {
        if (fs.existsSync(privateKeyPath)) await fsp.rm(privateKeyPath);
        if (fs.existsSync(publicKeyPath)) await fsp.rm(publicKeyPath);

        if (!fs.existsSync(privateKeyPath2) || !fs.existsSync(publicKeyPath2)){
            if (fs.existsSync(privateKeyPath2)) await fsp.rm(privateKeyPath2);
            if (fs.existsSync(publicKeyPath2)) await fsp.rm(publicKeyPath2);
            postStatus("生成SSH密钥...");
            const exec = util.promisify(cp.exec);
            await exec(`ssh-keygen -t ed25519 -f "${privateKeyPath}" -N ""`);
        }
        else if (fs.existsSync(privateKeyPath2) && fs.existsSync(publicKeyPath2)) {
            return;
        }
        
        if (!fs.existsSync(privateKeyPath) || !fs.existsSync(publicKeyPath)){
            postStatus("生成SSH密钥...");
            const exec = util.promisify(cp.exec);
            await exec(`ssh-keygen -t ed25519 -f "${privateKeyPath}" -N ""`);
        }
    }
}
